<div fxLayout="column">
    <table mat-table [dataSource]="uiDatas" class="edition-table"
           multiTemplateDataRows
           aria-describedby="table to edit artists">

        <ng-container matColumnDef="name">
            <th mat-header-cell *matHeaderCellDef scope="col"> {{'ARTIST.EDITION.TABLE.HEADERS.NAME' | translate}} </th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field mff-space-1" subscriptSizing="dynamic">
                    <input matInput formControlName="name">
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="avatar">
            <td mat-cell *matCellDef="let element; let index = dataIndex"></td>
        </ng-container>

        <ng-container matColumnDef="webLinks">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'ARTIST.EDITION.TABLE.HEADERS.WEBLINKS' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = dataIndex"
                [formGroup]="uiDatas[index].form">
                <ng-container *ngIf="uiDatas[index].item as item">
                    <div fxLayoutGap="1rem">
                        <button mat-button type="button"
                                (click)="expandedElement = expandedElement === index ? null : index">
                            <span *ngIf="item.webLinks.length > 0; else create"> {{'ARTIST.EDITION.BUTTON.EDIT' | translate}} </span>
                            <ng-template #create>
                                <span> {{'ARTIST.EDITION.BUTTON.CREATE' | translate}} </span>
                            </ng-template>
                            <fa-icon style="margin-left: 0.5rem" [icon]="['fas', 'pencil-alt']"></fa-icon>
                        </button>
                        <app-web-link-list [webLinks]="item.webLinks"></app-web-link-list>
                    </div>
                </ng-container>
            </td>
        </ng-container>

        <ng-container matColumnDef="webLinksExpand">
            <td mat-cell
                *matCellDef="let element; let index = dataIndex"
                [attr.colspan]="displayedColumns.length - 1 ">
                <div class="example-element-detail"
                     [@detailExpand]="index === expandedElement ? 'expanded' : 'collapsed'">
                    <div class="artist-weblinks-list-element"
                         *ngFor="let webLink of getWebLinksFormArray(index).controls; let i = index">
                        <app-web-links-form [form]="webLink" [types]="types"></app-web-links-form>
                        <button mat-button type="button" color="warn" (click)="deleteWebLink(index, i)">
                            <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                        </button>
                    </div>

                    <app-create-web-links [types]="types"
                                          (create)="addWebLink($event, index)"></app-create-web-links>
                </div>
            </td>
        </ng-container>

        <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef scope="col"></th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <div class="action-column-edition">
                    <div class="action-column-edition-buttons">
                        <button mat-button type="button" color="warn" [disabled]="!isRemovable(index)"
                                (click)="delete(index)">
                            <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                        </button>
                    </div>
                    <app-progressbar [start]="uiDatas[index].start" (finish)="onFinish(index)"></app-progressbar>
                </div>
            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row
            [ngClass]="{'edition-line': true, 'saved': (uiDatas[index].isSaved | async)}"
            *matRowDef="let element; columns: displayedColumns; let index = dataIndex">
        </tr>
        <tr mat-row *matRowDef="let row; columns: ['avatar','webLinksExpand']" class="example-detail-row"></tr>
    </table>
    <mat-paginator [pageSizeOptions]="pageSizes"
                   [pageIndex]="currentPage$ | async"
                   [length]="totalCount$ | async"
                   [pageSize]="pageSize$ | async"
                   (page)="onNewPage($event)">
    </mat-paginator>
</div>

